//					DASM.H

#ifndef dasmh
#define dasmh

#include "common.h"

#define CD_PUSHBP  1
#define CD_ENTER   2
#define CD_MOVBX   4

struct globaloptions
{ BOOL loaddebug;
  BOOL mode16,mode32;
  BOOL loaddata,loadresources;
  BOOL demangle;
  BOOL cfa;
  dword processor;
  lptr loadaddr;
  word dseg;
  word codedetect;
};

void StatusMessageNItems(dword nolistitems);

extern CRITICAL_SECTION cs;
extern HANDLE hInst;
extern HWND mainwindow;
extern globaloptions options;
extern RECT mainwnd;
extern volatile BOOL KillThread;
extern char winname[];

#define Status_SetText(hwnd, iPart, uType, szText) \
	 (BOOL)PostMessage((hwnd), SB_SETTEXT, (WPARAM) (iPart | uType), (LPARAM) (LPSTR) szText)

#endif