//			gname.h
//
// generic name class - class of items comprising names and locations
// - used for exports,imports and names classes
// - common parts separated into this class Build 16.

#ifndef gname_h
#define gname_h

#include "list.h"
#include "common.h"

#define GNAME_MAXLEN 40

struct gnameitem
{ lptr addr;
  char *name;
};

class gname:public slist
{ public:
    char *nme;
    BOOL repeater;

  public:
    gname();
    ~gname();
    void addname(lptr loc,char *nm);
    BOOL isname(lptr loc);
    void printname(lptr loc);
    BOOL savedb(HANDLE sfile);
    BOOL loaddb(HANDLE sfile);
    void delname(lptr loc);

  private: 
    void demangle(char **name);
};

#endif