@ECHO OFF
IF NOT $%OS% == $Windows_NT GOTO NTrequired
IF NOT $%PROCESSOR_ARCHITECTURE% == $x86 GOTO x86required
IF NOT EXIST %SystemRoot%\System32\Drivers\Nul GOTO DrivDirNotFound

IF EXIST %SystemRoot%\System32\Drivers\NTdump.sys SET Y=Y
COPY /B /V NTdump.sys %SystemRoot%\System32\Drivers >Nul
IF NOT ERRORLEVEL 0 GOTO CopyFailed

REM Remove previous installation 
IF EXIST %SystemRoot%\pntice.ini DEL %SystemRoot%\pntice.ini


%SystemRoot%\regedit.exe /m NTdump.reg

DEL  NTdump.sys
DEL  NTdump.reg

ECHO.
ECHO Congratulations!
ECHO NTiceSET was successfully installed.
IF   $%Y%==$Y GOTO Restart
ECHO Reboot, please...
GOTO END

:Restart
NET STOP  NTDUMP
NET START NTDUMP
GOTO END

:NTrequired
ECHO.
ECHO This product is designed for Windows NT
GOTO END

:x86required
ECHO.
ECHO This product is designed for x86 architecture
GOTO END

:DrivDirNotFound
ECHO.
ECHO Can't find Drivers directory
GOTO END

:CopyFailed
ECHO.
ECHO Can't copy NTdump.sys
GOTO END


:END 
SET Y=
PAUSE