;
;
;                          un-CodeCrypt (c) Lakan
;                   * unpacker for CodeCrypt v0.14 beta *
;
;  compile: nasmw -fwin32 uncode.asm
;           alink -oPE uncode.obj -subsys con kernel32.lib -entry start
;
;   syntax: uncode file.exe
;
;

extern          ExitProcess
extern          GetStdHandle
extern          SetUnhandledExceptionFilter
extern          WriteFile
extern          CloseHandle
extern          GetCommandLineA
extern          CreateFileA
extern          CreateFileMappingA
extern          MapViewOfFile
extern          UnmapViewOfFile
extern          SetFilePointer
extern          SetEndOfFile

;

segment         .text

global          start

start:          push    dword terminate
                call    SetUnhandledExceptionFilter

                push    dword -11
                call    GetStdHandle
                cmp     eax, -1
                jne     $+7
                jmp     terminate
                mov     [hConOut], eax

                call    GetCommandLineA
                xchg    edi, eax
                or      ecx, -1
                xor     eax, eax
                push    edi
                repnz   scasb
                not     ecx
                pop     edi
                mov     al, ' '
                repnz   scasb

                push    dword 0
                push    dword 80h       ; FILE_ATTRIBUTE_NORMAL
                push    dword 3         ; OPEN_EXISTING
                push    dword 0
                push    dword 0
                push    dword 0c0000000h ; GENERIC_READ+GENERIC_WRITE
                push    edi
                call    CreateFileA
                mov     [hFile], eax

                push    dword 0
                push    dword 0
                push    dword 0
                push    dword 4         ; PAGE_READWRITE
                push    dword 0
                push    eax
                call    CreateFileMappingA
                mov     [hFileMapping], eax

                push    dword 0
                push    dword 0
                push    dword 0
                push    dword 2         ; FILE_MAP_WRITE
                push    eax
                call    MapViewOfFile
                or      eax, eax
                jnz     $+7
                jmp     show_error

                mov     [lpBaseAddress], eax
                add     eax, [eax+3ch]
                mov     ebp, eax
                cmp     word [ebp], 'PE'
                jz      $+7
                jmp     show_error

                movzx   ecx, word [ebp+NumberOfSections]
                dec     ecx
                imul    ecx, ecx, IMAGE_SECTION_HEADER
                lea     eax, [ecx+eax+IMAGE_NT_HEADERS]
                mov     [Temp1], eax
                mov     edi, [eax+PointerToRawData]
                add     edi, [lpBaseAddress]
                mov     [Temp2], edi

                cmp     word [edi], 33e9h
                jz      $+7
                jmp     show_error

                lea     ebx, [edi+84ch]
                mov     ecx, 54h
decrypt1:       xor     byte [ebx], 64h
                add     byte [ebx], 65h
                rol     byte [ebx], 66h
                inc     ebx
                dec     ecx
                jnz     decrypt1

                lea     ebx, [edi+550h]
                mov     dl, byte [edi+8bfh]
                mov     ecx, 2fch
decrypt2:       xor     byte [ebx], dl
                xor     byte [ebx], cl
                inc     ebx
                dec     ecx
                jnz     decrypt2

                lea     ebx, [edi+55fh]
                mov     dl, byte [edi+85ch]
                mov     ecx, 2fch
decrypt3:       ror     byte [ebx], 4
                xor     byte [ebx], dl
                inc     ebx
                dec     ecx
                jnz     decrypt3

                lea     edx, [ebp+IMAGE_NT_HEADERS]
                mov     eax, [edi+854h]
                movzx   ecx, word [ebp+NumberOfSections]
nextrva:        cmp     eax, [edx+VirtualAddress]
                jz      rvafound
                dec     ecx
                jnz     $+7
                jmp     show_error
                add     edx, 28h
                jmp     nextrva
rvafound:       mov     ebx, [edx+PointerToRawData]
                add     ebx, [lpBaseAddress]
                push    ebx
                mov     eax, [edi+858h]
                push    eax

                mov     cl, [edi+861h]
decrypt4:       add     byte [ebx], cl
                ror     byte [ebx], cl
                inc     ebx
                dec     eax
                jnz     decrypt4

                mov     ecx, [esp]
                mov     ebx, [esp+4]

                xor     eax, eax
                mov     dl, [edi+85ch]
decrypt5:       inc     eax
                xor     byte [ebx], al
                ror     byte [ebx], 5
                xor     byte [ebx], dl
                rol     byte [ebx], 7
                inc     ebx
                dec     ecx
                jnz     decrypt5

                mov     ebx, [Temp2]
                xor     eax, eax
                mov     ecx, 84ch
decrypt6:       add     al, byte [ebx]
                inc     ebx
                dec     ecx
                jnz     decrypt6

                pop     ecx
                pop     ebx

                mov     dl, al
decrypt7:       ror     byte [ebx], cl
                xor     byte [ebx], dl
                sub     byte [ebx], dl
                inc     ebx
                dec     ecx
                jnz     decrypt7

                mov     eax, [edi+84ch]
                sub     eax, [edi+850h]
                mov     [ebp+AddressOfEntryPoint], eax

                dec     word [ebp+NumberOfSections]

                lea     edx, [ebp+IMAGE_NT_HEADERS]
                or      dword [edx+Flags], 20000000h

                mov     edi, [Temp1]
                mov     ebx, [edi+PointerToRawData]
                mov     ecx, IMAGE_SECTION_HEADER
                xor     eax, eax
                rep     stosb

                push    dword [lpBaseAddress]
                call    UnmapViewOfFile

                push    dword [hFileMapping]
                call    CloseHandle

                push    dword 0
                push    dword 0
                push    ebx
                push    dword [hFile]
                call    SetFilePointer

                push    dword [hFile]
                call    SetEndOfFile

                push    dword [hFile]
                call    CloseHandle

                push    dword 0
                push    dword BytesRead
                push    dword 2
                push    dword Msg1
                push    dword [hConOut]
                call    WriteFile

terminate:      push    dword 0
                call    ExitProcess

show_error:     push    dword 0
                push    dword BytesRead
                push    dword 5
                push    dword Msg2
                push    dword [hConOut]
                call    WriteFile

                jmp     terminate

;

segment         .bss

IMAGE_NT_HEADERS        equ     0f8h
IMAGE_SECTION_HEADER    equ     28h

NumberOfSections        equ     6
AddressOfEntryPoint     equ     28h
VirtualAddress          equ     0ch
PointerToRawData        equ     14h
Flags                   equ     24h

Temp1                   resd    1
Temp2                   resd    1
Temp3                   resd    1

BytesRead               resd    1
hConOut                 resd    1
lpBaseAddress           resd    1
hFile                   resd    1
hFileMapping            resd    1

segment         .data

Msg1                    db      'Ok'
Msg2                    db      'Error'


